(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-x11")

(define current-data (woo-read-first "/x11"))

(define current-xdriver (woo-get-option current-data 'xdriver #f))
(define current-xdriver-name (woo-get-option current-data 'xdrivername #f))

(define xdriver-list (woo-list/name+label "/x11/avail_xdriver"))

(define (get-variant lst w)
  (car (list-ref lst (w current))))

(define (current-index x lst)
  (and (string? x)
       (list-index (lambda(y) (string=? (car y) x)) lst)))

(define (default-variant lst cur def)
  (list rows (map cdr lst)
        current (or (current-index  cur lst) def)))

(define (return) (frame:replace "/x11"))

(label (_ "Drivers"))
(document:id driver
             (listbox (default-variant xdriver-list current-xdriver 0)))
(hbox
 (button (_ "OK")
         (when clicked (woo-write "/x11/driver" 'xdriver (get-variant xdriver-list driver))
               (return)))
  (button (_"Cancel")
          (when clicked (return))))

(and (global 'frame:next)
     (document:root (when loaded
                      (frame:next-activity #f)
                      (frame:back-activity #f))))
