(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-x11")

(define (return) (frame:replace "/x11"))

(define (current-index x lst)
  (and (string? x)
       (list-index (lambda(y) (string=? (car y) x)) lst)))

(define vendors-list (woo-list/name+label "/x11/monitor/avail_vendor"))

(define current-data (woo-read-first "/x11/monitor"))
(define current-vendor (woo-get-option current-data 'vendor #f))

(label (_ "Vendors"))
(document:id vendors
             (listbox rows (map cdr vendors-list)
                      current (or (current-index current-vendor vendors-list) 0)))
(hbox
 (button (_ "OK")
         (when clicked (woo-write "/x11/monitor" 'vendor (car (list-ref vendors-list (vendors current))))
               (return)))
  (button (_"Cancel")
          (when clicked (return))))

(and (global 'frame:next)
     (document:root (when loaded
                      (frame:next-activity #f)
                      (frame:back-activity #f))))

